##~~~~~~~~~~~~~~~~~~~~~~##
#### Summarizing Bias ####
##~~~~~~~~~~~~~~~~~~~~~~##
rm(list = ls())

n40d2 <- read.csv("sim output 40n dsr91 10000 nests 2 day.csv", header=T)
n40d3 <- read.csv("sim output 40n dsr91 10000 nests 3 day.csv", header=T)
n40d4 <- read.csv("sim output 40n dsr91 10000 nests 4 day.csv", header=T)
n40d5 <- read.csv("sim output 40n dsr91 10000 nests 5 day.csv", header=T)
n40d6 <- read.csv("sim output 40n dsr91 10000 nests 6 day.csv", header=T)
n40d7 <- read.csv("sim output 40n dsr91 10000 nests 7 day.csv", header=T)

n100d2 <- read.csv("sim output 100n dsr91 10000 nests 2 day.csv", header=T)
n100d3 <- read.csv("sim output 100n dsr91 10000 nests 3 day.csv", header=T)
n100d4 <- read.csv("sim output 100n dsr91 10000 nests 4 day.csv", header=T)
n100d5 <- read.csv("sim output 100n dsr91 10000 nests 5 day.csv", header=T)
n100d6 <- read.csv("sim output 100n dsr91 10000 nests 6 day.csv", header=T)
n100d7 <- read.csv("sim output 100n dsr91 10000 nests 7 day.csv", header=T)

n400d2 <- read.csv("sim output 400n dsr91 10000 nests 2 day.csv", header=T)
n400d3 <- read.csv("sim output 400n dsr91 10000 nests 3 day.csv", header=T)
n400d4 <- read.csv("sim output 400n dsr91 10000 nests 4 day.csv", header=T)
n400d5 <- read.csv("sim output 400n dsr91 10000 nests 5 day.csv", header=T)
n400d6 <- read.csv("sim output 400n dsr91 10000 nests 6 day.csv", header=T)
n400d7 <- read.csv("sim output 400n dsr91 10000 nests 7 day.csv", header=T)

bias <- data.frame(nests=as.character(c(rep.int(40, 12), rep.int(100, 12), rep.int(400, 12))), 
                   interval=as.numeric(rep.int(c(2,2,3,3,4,4,5,5,6,6,7,7), 3)), 
                   scale=as.character(rep.int(c("fine", "coarse"), 18)), 
                   mean_bias=as.numeric(rep.int(NA, 36)),
                   se_bias=as.numeric(rep.int(NA, 36)),
                   lcl_bias=as.numeric(rep.int(NA, 36)),
                   ucl_bias=as.numeric(rep.int(NA, 36)))

# Calculating mean bias
bias[1,4]  <- mean(n40d2$bias[n40d2$Scale=="fine"])
bias[2,4]  <- mean(n40d2$bias[n40d2$Scale=="coarse"])
bias[3,4]  <- mean(n40d3$bias[n40d3$Scale=="fine"])
bias[4,4]  <- mean(n40d3$bias[n40d3$Scale=="coarse"])
bias[5,4]  <- mean(n40d4$bias[n40d4$Scale=="fine"])
bias[6,4]  <- mean(n40d4$bias[n40d4$Scale=="coarse"])
bias[7,4]  <- mean(n40d5$bias[n40d5$Scale=="fine"])
bias[8,4]  <- mean(n40d5$bias[n40d5$Scale=="coarse"])
bias[9,4]  <- mean(n40d6$bias[n40d6$Scale=="fine"])
bias[10,4] <- mean(n40d6$bias[n40d6$Scale=="coarse"])
bias[11,4] <- mean(n40d7$bias[n40d7$Scale=="fine"])
bias[12,4] <- mean(n40d7$bias[n40d7$Scale=="coarse"])

bias[13,4] <- mean(n100d2$bias[n100d2$Scale=="fine"])
bias[14,4] <- mean(n100d2$bias[n100d2$Scale=="coarse"])
bias[15,4] <- mean(n100d3$bias[n100d3$Scale=="fine"])
bias[16,4] <- mean(n100d3$bias[n100d3$Scale=="coarse"])
bias[17,4] <- mean(n100d4$bias[n100d4$Scale=="fine"])
bias[18,4] <- mean(n100d4$bias[n100d4$Scale=="coarse"])
bias[19,4] <- mean(n100d5$bias[n100d5$Scale=="fine"])
bias[20,4] <- mean(n100d5$bias[n100d5$Scale=="coarse"])
bias[21,4] <- mean(n100d6$bias[n100d6$Scale=="fine"])
bias[22,4] <- mean(n100d6$bias[n100d6$Scale=="coarse"])
bias[23,4] <- mean(n100d7$bias[n100d7$Scale=="fine"])
bias[24,4] <- mean(n100d7$bias[n100d7$Scale=="coarse"])

bias[25,4] <- mean(n400d2$bias[n400d2$Scale=="fine"])
bias[26,4] <- mean(n400d2$bias[n400d2$Scale=="coarse"])
bias[27,4] <- mean(n400d3$bias[n400d3$Scale=="fine"])
bias[28,4] <- mean(n400d3$bias[n400d3$Scale=="coarse"])
bias[29,4] <- mean(n400d4$bias[n400d4$Scale=="fine"])
bias[30,4] <- mean(n400d4$bias[n400d4$Scale=="coarse"])
bias[31,4] <- mean(n400d5$bias[n400d5$Scale=="fine"])
bias[32,4] <- mean(n400d5$bias[n400d5$Scale=="coarse"])
bias[33,4] <- mean(n400d6$bias[n400d6$Scale=="fine"])
bias[34,4] <- mean(n400d6$bias[n400d6$Scale=="coarse"])
bias[35,4] <- mean(n400d7$bias[n400d7$Scale=="fine"])
bias[36,4] <- mean(n400d7$bias[n400d7$Scale=="coarse"])

# Calculating Monte Carlo Error
bias[1,5]  <- sd(n40d2$bias[n40d2$Scale=="fine"])/sqrt(length(n40d2$bias[n40d2$Scale=="fine"]))
bias[2,5]  <- sd(n40d2$bias[n40d2$Scale=="coarse"])/sqrt(length(n40d2$bias[n40d2$Scale=="coarse"]))
bias[3,5]  <- sd(n40d3$bias[n40d3$Scale=="fine"])/sqrt(length(n40d3$bias[n40d3$Scale=="fine"]))
bias[4,5]  <- sd(n40d3$bias[n40d3$Scale=="coarse"])/sqrt(length(n40d3$bias[n40d3$Scale=="coarse"]))
bias[5,5]  <- sd(n40d4$bias[n40d4$Scale=="fine"])/sqrt(length(n40d4$bias[n40d4$Scale=="fine"]))
bias[6,5]  <- sd(n40d4$bias[n40d4$Scale=="coarse"])/sqrt(length(n40d4$bias[n40d4$Scale=="coarse"]))
bias[7,5]  <- sd(n40d5$bias[n40d5$Scale=="fine"])/sqrt(length(n40d5$bias[n40d5$Scale=="fine"]))
bias[8,5]  <- sd(n40d5$bias[n40d5$Scale=="coarse"])/sqrt(length(n40d5$bias[n40d5$Scale=="coarse"]))
bias[9,5]  <- sd(n40d6$bias[n40d6$Scale=="fine"])/sqrt(length(n40d6$bias[n40d6$Scale=="fine"]))
bias[10,5] <- sd(n40d6$bias[n40d6$Scale=="coarse"])/sqrt(length(n40d6$bias[n40d6$Scale=="coarse"]))
bias[11,5] <- sd(n40d7$bias[n40d7$Scale=="fine"])/sqrt(length(n40d7$bias[n40d7$Scale=="fine"]))
bias[12,5] <- sd(n40d7$bias[n40d7$Scale=="coarse"])/sqrt(length(n40d7$bias[n40d7$Scale=="coarse"]))

bias[13,5] <- sd(n100d2$bias[n100d2$Scale=="fine"])/sqrt(length(n100d2$bias[n100d2$Scale=="fine"]))
bias[14,5] <- sd(n100d2$bias[n100d2$Scale=="coarse"])/sqrt(length(n100d2$bias[n100d2$Scale=="coarse"]))
bias[15,5] <- sd(n100d3$bias[n100d3$Scale=="fine"])/sqrt(length(n100d3$bias[n100d3$Scale=="fine"]))
bias[16,5] <- sd(n100d3$bias[n100d3$Scale=="coarse"])/sqrt(length(n100d3$bias[n100d3$Scale=="coarse"]))
bias[17,5] <- sd(n100d4$bias[n100d4$Scale=="fine"])/sqrt(length(n100d4$bias[n100d4$Scale=="fine"]))
bias[18,5] <- sd(n100d4$bias[n100d4$Scale=="coarse"])/sqrt(length(n100d4$bias[n100d4$Scale=="coarse"]))
bias[19,5] <- sd(n100d5$bias[n100d5$Scale=="fine"])/sqrt(length(n100d5$bias[n100d5$Scale=="fine"]))
bias[20,5] <- sd(n100d5$bias[n100d5$Scale=="coarse"])/sqrt(length(n100d5$bias[n100d5$Scale=="coarse"]))
bias[21,5] <- sd(n100d6$bias[n100d6$Scale=="fine"])/sqrt(length(n100d6$bias[n100d6$Scale=="fine"]))
bias[22,5] <- sd(n100d6$bias[n100d6$Scale=="coarse"])/sqrt(length(n100d6$bias[n100d6$Scale=="coarse"]))
bias[23,5] <- sd(n100d7$bias[n100d7$Scale=="fine"])/sqrt(length(n100d7$bias[n100d7$Scale=="fine"]))
bias[24,5] <- sd(n100d7$bias[n100d7$Scale=="coarse"])/sqrt(length(n100d7$bias[n100d7$Scale=="coarse"]))

bias[25,5] <- sd(n400d2$bias[n400d2$Scale=="fine"])/sqrt(length(n400d2$bias[n400d2$Scale=="fine"]))
bias[26,5] <- sd(n400d2$bias[n400d2$Scale=="coarse"])/sqrt(length(n400d2$bias[n400d2$Scale=="coarse"]))
bias[27,5] <- sd(n400d3$bias[n400d3$Scale=="fine"])/sqrt(length(n400d3$bias[n400d3$Scale=="fine"]))
bias[28,5] <- sd(n400d3$bias[n400d3$Scale=="coarse"])/sqrt(length(n400d3$bias[n400d3$Scale=="coarse"]))
bias[29,5] <- sd(n400d4$bias[n400d4$Scale=="fine"])/sqrt(length(n400d4$bias[n400d4$Scale=="fine"]))
bias[30,5] <- sd(n400d4$bias[n400d4$Scale=="coarse"])/sqrt(length(n400d4$bias[n400d4$Scale=="coarse"]))
bias[31,5] <- sd(n400d5$bias[n400d5$Scale=="fine"])/sqrt(length(n400d5$bias[n400d5$Scale=="fine"]))
bias[32,5] <- sd(n400d5$bias[n400d5$Scale=="coarse"])/sqrt(length(n400d5$bias[n400d5$Scale=="coarse"]))
bias[33,5] <- sd(n400d6$bias[n400d6$Scale=="fine"])/sqrt(length(n400d6$bias[n400d6$Scale=="fine"]))
bias[34,5] <- sd(n400d6$bias[n400d6$Scale=="coarse"])/sqrt(length(n400d6$bias[n400d6$Scale=="coarse"]))
bias[35,5] <- sd(n400d7$bias[n400d7$Scale=="fine"])/sqrt(length(n400d7$bias[n400d7$Scale=="fine"]))
bias[36,5] <- sd(n400d7$bias[n400d7$Scale=="coarse"])/sqrt(length(n400d7$bias[n400d7$Scale=="coarse"]))

bias$lcl_bias <- bias$mean_bias - (bias$se_bias * 1.96)
bias$ucl_bias <- bias$mean_bias + (bias$se_bias * 1.96)

#writeClipboard(as.character(mean(output.combined$bias[output.combined$Scale=="fine"])))
#writeClipboard(as.character(mean(output.combined$bias[output.combined$Scale=="coarse"])))

bias$nests <- factor(bias$nests, levels=c("40","100","400"))

library(ggplot2)
library(extrafont)

ggplot() +
  geom_line(data=bias, aes(x=interval, y=mean_bias, group=interaction(nests, scale), color=nests, linetype=scale), size=1) +
  scale_color_manual(name = "Starting nest number",
                     labels = c("40 nests", "100 nests", "400 nests"),
                     values = c("#C8102E", "orange4", "#F1BE48")) +
  geom_errorbar(data=bias, aes(x= interval, ymin=lcl_bias, ymax=ucl_bias), width=0.2, position=position_dodge(0.05)) +
  theme(text=element_text(family="Times New Roman", size=12))+
  xlab("Visit interval") +
  ylab("DSR Bias")

# ggsave("bias_error_bars.png", device='png', width=7, height=7)

bias <- group_by(bias, nests, scale)
delta_bias <- bias$mean_bias[bias$scale=="fine"] - bias$mean_bias[bias$scale=="coarse"]
bias.diff <- data.frame(nests=as.character(c(rep.int(40, 6), rep.int(100, 6), rep.int(400, 6))), 
                        interval=as.numeric(rep.int(c(2,3,4,5,6,7), 3)), 
                        delta_bias=delta_bias)

bias.diff$nests <- factor(bias.diff$nests, levels(bias.diff$nests)[c(2,1,3)])

ggplot() +
  geom_line(data=bias.diff, aes(x=interval, y=delta_bias, group=nests, color=nests), size=1) +
  scale_color_manual(name = "Starting nest number",
                     labels = c("40 nests", "100 nests", "400 nests"),
                     values = c("#C8102E", "orange4", "#F1BE48")) +
  theme(text=element_text(family="Times New Roman", size=12))+
  xlab("Visit interval") +
  ylab("DSR Delta Bias")

# ggsave("delta bias.png", device='png', width=7, height=7)